function [P,D] = matrixPD(DF,DC,f0,y,dt,p_min,p_max,L,key)
%       ()
%  .. 2016 akhmetsadinrd@mail.ru
% :
% DF - -     N1;
% DC -     ( )
%       N1xM1 (M1 );
% f0 -  ;
% y  -     NxM;
% dt -   ;
% p_min,p_max,L -      slowness;
% key - = 0  ,
%       = 1        .
% 
% P    P  N_FFT2xL;
% D    D  N_FFT2xL.
[N,M] = size(y);
N_FFT = 2^nextpow2(N);
N_FFT2 = N_FFT/2;
f = (0:N_FFT2-1)*(1/(N_FFT*dt));
p = linspace(p_min,p_max,L);
%%  
P = repmat(p,N_FFT2,1);
D = P;
p0 = interp1(DF,DC,f0,'linear');
Ind = find((p>=p0(1)) & (p<=p0(end)));
p11=p(Ind);
for i = 1:N_FFT2
    if (f(i)>=DF(1)) && (f(i)<=DF(end))
        p1 = interp1(DF,DC,f(i),'linear');
        p2 = interp1(p0,p1,p11,'linear');
        D(i,Ind) = p2;
        if key == 1 %     
            for k = 1:L
                q1 = p(k);
                if (q1 > p2(1)) && (q1 < p11(1))
                    D(i,k) = p2(1);
                end
                if (q1 > p11(end)) && (q1 < p2(end))
                    D(i,k) = p2(end);
                end
            end
        end
    end
end
